select
    an.numero,
    up.data as ultimo_parto,
    tpar.descricao as tp_parto,
    cob.data as dt_cobertura,
   (case cob.condicaoia when 'I' then 'Protocolo' when 'N' then 'Cio Natural' when 'P' then 'Prostaglandina' else null end) as condicao_ia,
    prot.descricao as protocolo_utilizado, 
    prev.data as dt_diagnostico,
    (case when ((prev.cdtiporeproducao in (1,2,3)) or (prev.cio in (1,2)) or (prev.diagnostico = 'N')) then 'Negativo'
       when (prev.diagnostico = 'P') then 'Positivo' else null end) as dg,
    par.data as dt_parto,
    (select count (*) from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao in (1,2,3) and
        re.data <= (coalesce(par.data,current_date)) and re.data > (coalesce(up.data, '1900-01-01')) and
        re.data <= cob.data) as IA,
    (select count(*) from reproducao re where re.cdanimal = an.cdanimal and re.data <= cob.data/*(coalesce(par.data,current_date))*/ and
        re.cdtiporeproducao = 7) as OP,
    tou.numero as touro,
    (select grausangue from sp_calculagrausangue(an.cdanimal)) as GS_Animal,
    (case when (lac.cdlactacao is not null) then
        (select producao305 from sp_producao305(lac.cdlactacao))
    else null end) as producao_305,
    (case when (par.retencaoplacenta = '1') then 'Sim' when (par.retencaoplacenta = '0') then 'No' else null end) as retencao_placenta_parto_atual,
    (case when (up.retencaoplacenta = '1') then 'Sim' when (up.retencaoplacenta = '0') then 'No' else null end) as retencao_placenta_ultimo_parto,
    tp.descricao,
    Extract (Month from cob.data) as Mes_Cob,
    Extract (Year from cob.data) as Ano_Cob,
    cob.data - up.data as DEL,
    (case when (pico.cdleite is not null) then (select producaototal from sp_calculaproducaototal(lac.cdlactacao,pico.dtleite)) else null end) as producao_pico,
    (case when (pico.cdleite is not null) then (pico.dtleite - lac.dtinicio) else null end) as del_pico,
    (case when (lac.dtfim is not null) then (lac.dtfim - lac.dtinicio) else null end) as duracao_lactacao,
    (case when (lac.cdlactacao is not null) then 'Lactao' else 'Seca' end) as situacao_produtiva_ia,
    lac.dtfim as data_secagem,
    (case when (lacant.cdlactacao is not null) then (up.data - lacant.dtfim) else null end) as periodo_seco_anterior,
    (case when (lacant.dtfim is not null) then (select producaototal from sp_calculaproducaototal(lacant.cdlactacao,lacant.dtfim)) else null end) as producao_lactacao_anterior,
    pes.nome as inseminador,
    ((cob.data - an.dtnascimento)/30.5) as idade_cob_meses
from
    animal an
    join reproducao cob on cob.cdanimal = an.cdanimal
    left join reproducao prev on prev.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.data > cob.data
        and ((re.cdtiporeproducao in (1,2,3,7)) or (re.cio in (1,2)) or (re.diagnostico is not null)) order by re.data)
    left join reproducao par on par.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.data > prev.data
        and re.cdtiporeproducao = 7
        and not exists
            (select * from reproducao re2 where re2.cdanimal = re.cdanimal and re2.data > prev.data and re2.data
            < re.data and ((re2.cdtiporeproducao in (1,2,3)) or (re2.diagnostico is not null) or (re2.cio in
            (1,2)))order by re2.data)
        )
    left join reproducao up on up.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = an.cdanimal and re.cdtiporeproducao = 7
        and re.data < cob.data order by re.data desc)
    left join animal tou on tou.cdanimal = cob.cdreprodutor
    left join lactacao lac on lac.cdlactacao =
        (select re.cdlactacao from lactacao re where re.cdanimal = an.cdanimal and re.dtinicio < cob.data and
            ((re.dtfim is null) or (re.dtfim > cob.data) ))
    left join tiporeproducao tp on cob.cdtiporeproducao=tp.cdtiporeproducao
    left join tipoparto tpar on tpar.cdtipoparto = up.cdtipoparto
    left join leite pico on pico.cdleite =
        (select first 1 re.cdleite from leite re where re.cdlactacao = lac.cdlactacao order by re.pesototal desc)
    left join lactacao lacant on lacant.cdlactacao =
        (select first 1 re.cdlactacao from lactacao re where re.cdanimal = cob.cdanimal and re.dtfim < cob.data order by re.dtfim desc)
    left join pessoa pes on pes.cdpessoa = cob.cdpessoa
    left join protocoloiatf prot on prot.cdprotocoloiatf = cob.cdprotocoloiatf
where
    cob.cdtiporeproducao in (1,2,3)
    and cob.data between '2011-01-01' and '2011-12-31'
order by
    an.numero, cob.data

